int motorLpin1 = 4;  
int motorLpin2 = 5;
int motorRpin1 = 6;  
int motorRpin2 = 7;  
int motorLpwm = 3;  
int motorRpwm = 9;  
int motorSpeed = 75;  
int turn = 25;

void setup() {  
    Serial.begin(9600);  
    Serial.flush();
    pinMode(motorLpin1, OUTPUT);  
    pinMode(motorLpin2, OUTPUT);  
    pinMode(motorRpin1, OUTPUT);  
    pinMode(motorRpin2, OUTPUT);  
    pinMode(motorLpwm, OUTPUT);  
    pinMode(motorRpwm, OUTPUT);
    stp();
}

void loop() {
    String input = "";  
    while (Serial.available()) {  
        input += (char) Serial.read();  
        delay(5);  
    }  
    if (input == "n") {  
        stp();  
    } else if (input == "F") {  
        fwd();  
    } else if (input == "R") {  
        rev();  
    } else if (input.indexOf("TL") > -1) {  
        lft();  
    } else if (input.indexOf("TR") > -1) {  
        rght();  
    } else if (input != "") {  
        motorSpeed = input.toInt();

        if (motorSpeed < 0) {
          motorSpeed = 0;
        }

        if (motorSpeed > 255) {
          motorSpeed = 255;
        }
    }
}

void fwd() { 
    analogWrite(motorLpwm, motorSpeed);  
    analogWrite(motorRpwm, motorSpeed);
    digitalWrite(motorLpin1, 0);  
    digitalWrite(motorLpin2, 1);  
    digitalWrite(motorRpin1, 0);  
    digitalWrite(motorRpin2, 1);  
}  

void rev() {  
    analogWrite(motorLpwm, motorSpeed);  
    analogWrite(motorRpwm, motorSpeed);
    digitalWrite(motorLpin1, 1);  
    digitalWrite(motorLpin2, 0);  
    digitalWrite(motorRpin1, 1);  
    digitalWrite(motorRpin2, 0); 
}

void rght() {
    if (motorSpeed - turn <= 0) {
      analogWrite(motorLpwm, 0);  
    } else {
      analogWrite(motorLpwm, motorSpeed - turn);  
    }

    if (motorSpeed + turn >= 255) {
      analogWrite(motorLpwm, 255);  
    } else {
      analogWrite(motorRpwm, motorSpeed + turn);
    }

    digitalWrite(motorLpin1, 0);  
    digitalWrite(motorLpin2, 1);  
    digitalWrite(motorRpin1, 1);  
    digitalWrite(motorRpin2, 0);  
}

void lft() {
    if (motorSpeed + turn >= 255) {
      analogWrite(motorLpwm, 255);  
    } else {
      analogWrite(motorLpwm, motorSpeed + turn);
    }

    if (motorSpeed - turn <= 0) {
      analogWrite(motorRpwm, 0);  
    } else {
      analogWrite(motorRpwm, motorSpeed - turn);  
    }

    digitalWrite(motorLpin1, 1);  
    digitalWrite(motorLpin2, 0);  
    digitalWrite(motorRpin1, 0);  
    digitalWrite(motorRpin2, 1);  
}

void stp() {  
    analogWrite(motorLpwm, 0);  
    analogWrite(motorRpwm, 0);  
    digitalWrite(motorLpin1, 1);  
    digitalWrite(motorLpin2, 1);  
    digitalWrite(motorRpin1, 1);  
    digitalWrite(motorRpin2, 1);  
}  
